3 # Copyright (c) 2005 Junio C Hamano
6 # Keep the original TERM for say_color
9 # For repeatability, reset the environment to known value.
15 export LANG LC_ALL PAGER TERM TZ
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
27 GIT_AUTHOR_EMAIL
=author@example.com
28 GIT_AUTHOR_NAME
='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL
=committer@example.com
31 GIT_COMMITTER_NAME
='C O Mitter'
35 unset GIT_EXTERNAL_DIFF
37 unset GIT_OBJECT_DIRECTORY
38 unset GIT_CEILING_DIRECTORIES
39 unset SHA1_FILE_DIRECTORIES
40 unset SHA1_FILE_DIRECTORY
42 export GIT_MERGE_VERBOSITY
43 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
46 GIT_TEST_CMP
=${GIT_TEST_CMP:-diff -u}
48 # Protect ourselves from common misconfiguration to export
49 # CDPATH into the environment
52 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
54 echo "* warning: Some tests will not work if GIT_TRACE" \
55 "is set as to trace on STDERR ! *"
56 echo "* warning: Please set GIT_TRACE to something" \
57 "other than 1, 2 or true ! *"
61 # Each test should start with something like this, after copyright notices:
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68 TERM
=$ORIGINAL_TERM &&
71 tput bold
>/dev
/null
2>&1 &&
72 tput setaf
1 >/dev
/null
2>&1 &&
73 tput sgr0
>/dev
/null
2>&1
80 -d|
--d|
--de|
--deb|
--debu|
--debug)
82 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
84 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
85 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
86 -h|
--h|
--he|
--hel|
--help)
88 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
90 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
102 if test -n "$color"; then
108 error
) tput bold
; tput setaf
1;; # bold red
109 skip
) tput bold
; tput setaf
2;; # bold green
110 pass
) tput setaf
2;; # green
111 info
) tput setaf
3;; # brown
112 *) test -n "$quiet" && return;;
122 test -z "$1" && test -n "$quiet" && return
129 say_color error
"error: $*"
138 test "${test_description}" != "" ||
139 error
"Test script did not set test_description."
141 if test "$help" = "t"
143 echo "$test_description"
148 if test "$verbose" = "t"
152 exec 4>/dev
/null
3>/dev
/null
162 echo >&5 "FATAL: Unexpected exit with code $?"
168 # The semantics of the editor variables are that of invoking
169 # sh -c "$EDITOR \"$@\"" files ...
171 # If our trash directory contains shell metacharacters, they will be
172 # interpreted if we just set $EDITOR directly, so do a little dance with
173 # environment variables to work around this.
175 # In particular, quoting isn't enough, as the path may contain the same quote
180 VISUAL
='"$FAKE_EDITOR"'
185 if test -z "${test_tick+set}"
189 test_tick
=$
(($test_tick + 60))
191 GIT_COMMITTER_DATE
="$test_tick -0700"
192 GIT_AUTHOR_DATE
="$test_tick -0700"
193 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
196 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
198 # This will commit a file with the given contents and the given commit
199 # message. It will also add a tag with <message> as name.
201 # Both <file> and <contents> default to <message>.
205 echo "${3-$1}" > "$file" &&
208 git commit
-m "$1" &&
212 # Call test_merge with the arguments "<message> <commit>", where <commit>
213 # can be a tag pointing to the commit-to-merge.
217 git merge
-m "$1" "$2" &&
221 # You are not expected to call test_ok_ and test_failure_ directly, use
222 # the text_expect_* functions instead.
225 test_count
=$
(expr "$test_count" + 1)
226 test_success
=$
(expr "$test_success" + 1)
227 say_color
"" " ok $test_count: $@"
231 test_count
=$
(expr "$test_count" + 1)
232 test_failure
=$
(expr "$test_failure" + 1);
233 say_color error
"FAIL $test_count: $1"
235 echo "$@" |
sed -e 's/^/ /'
236 test "$immediate" = "" ||
{ trap - EXIT
; exit 1; }
239 test_known_broken_ok_
() {
240 test_count
=$
(expr "$test_count" + 1)
241 test_fixed
=$
(($test_fixed+1))
242 say_color
"" " FIXED $test_count: $@"
245 test_known_broken_failure_
() {
246 test_count
=$
(expr "$test_count" + 1)
247 test_broken
=$
(($test_broken+1))
248 say_color skip
" still broken $test_count: $@"
252 test "$debug" = "" ||
eval "$1"
262 this_test
=$
(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
263 this_test
="$this_test.$(expr "$test_count" + 1)"
265 for skp
in $GIT_SKIP_TESTS
274 say_color skip
>&3 "skipping test: $@"
275 test_count
=$
(expr "$test_count" + 1)
276 say_color skip
"skip $test_count: $1"
285 test_expect_failure
() {
287 error
"bug in the test script: not 2 parameters to test-expect-failure"
290 say
>&3 "checking known breakage: $2"
292 if [ "$?" = 0 -a "$eval_ret" = 0 ]
294 test_known_broken_ok_
"$1"
296 test_known_broken_failure_
"$1"
302 test_expect_success
() {
304 error
"bug in the test script: not 2 parameters to test-expect-success"
307 say
>&3 "expecting success: $2"
309 if [ "$?" = 0 -a "$eval_ret" = 0 ]
319 test_expect_code
() {
321 error
"bug in the test script: not 3 parameters to test-expect-code"
324 say
>&3 "expecting exit code $1: $3"
326 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
336 # test_external runs external test scripts that provide continuous
337 # test output about their progress, and succeeds/fails on
338 # zero/non-zero exit code. It outputs the test output on stdout even
339 # in non-verbose mode, and announces the external script with "* run
340 # <n>: ..." before running it. When providing relative paths, keep in
341 # mind that all scripts run in "trash directory".
342 # Usage: test_external description command arguments...
343 # Example: test_external 'Perl API' perl ../path/to/test.pl
346 error
>&5 "bug in the test script: not 3 parameters to test_external"
349 if ! test_skip
"$descr" "$@"
351 # Announce the script to reduce confusion about the
352 # test output that follows.
353 say_color
"" " run $(expr "$test_count" + 1): $descr ($*)"
354 # Run command; redirect its stderr to &4 as in
355 # test_run_, but keep its stdout on our stdout even in
362 test_failure_
"$descr" "$@"
367 # Like test_external, but in addition tests that the command generated
368 # no output on stderr.
369 test_external_without_stderr
() {
370 # The temporary file has no (and must have no) security
372 tmp
="$TMPDIR"; if [ -z "$tmp" ]; then tmp
=/tmp
; fi
373 stderr
="$tmp/git-external-stderr.$$.tmp"
374 test_external
"$@" 4> "$stderr"
375 [ -f "$stderr" ] || error
"Internal error: $stderr disappeared."
376 descr
="no stderr: $1"
378 say
>&3 "expecting no stderr from previous command"
379 if [ ! -s "$stderr" ]; then
383 if [ "$verbose" = t
]; then
384 output
=`echo; echo Stderr is:; cat "$stderr"`
388 # rm first in case test_failure exits.
390 test_failure_
"$descr" "$@" "$output"
394 # This is not among top-level (test_expect_success | test_expect_failure)
395 # but is a prefix that can be used in the test script, like:
397 # test_expect_success 'complain and die' '
399 # do something else &&
400 # test_must_fail git checkout ../outerspace
403 # Writing this as "! git checkout ../outerspace" is wrong, because
404 # the failure could be due to a segv. We want a controlled failure.
408 test $?
-gt 0 -a $?
-le 129 -o $?
-gt 192
411 # test_cmp is a helper function to compare actual and expected output.
412 # You can use it like:
414 # test_expect_success 'foo works' '
415 # echo expected >expected &&
417 # test_cmp expected actual
420 # This could be written as either "cmp" or "diff -u", but:
421 # - cmp's output is not nearly as easy to read as diff -u
422 # - not all diff versions understand "-u"
428 # Most tests can use the created repository, but some may need to create more.
429 # Usage: test_create_repo <directory>
430 test_create_repo
() {
432 error
"bug in the test script: not 1 parameter to test-create-repo"
436 cd "$repo" || error
"Cannot setup test environment"
437 "$GIT_EXEC_PATH/git" init
"--template=$GIT_EXEC_PATH/templates/blt/" >&3 2>&4 ||
438 error
"cannot run git init -- have you built things yet?"
439 mv .git
/hooks .git
/hooks-disabled
445 test_results_dir
="$TEST_DIRECTORY/test-results"
446 mkdir
-p "$test_results_dir"
447 test_results_path
="$test_results_dir/${0%-*}-$$"
449 echo "total $test_count" >> $test_results_path
450 echo "success $test_success" >> $test_results_path
451 echo "fixed $test_fixed" >> $test_results_path
452 echo "broken $test_broken" >> $test_results_path
453 echo "failed $test_failure" >> $test_results_path
454 echo "" >> $test_results_path
456 if test "$test_fixed" != 0
458 say_color pass
"fixed $test_fixed known breakage(s)"
460 if test "$test_broken" != 0
462 say_color error
"still have $test_broken known breakage(s)"
463 msg
="remaining $(($test_count-$test_broken)) test(s)"
465 msg
="$test_count test(s)"
467 case "$test_failure" in
470 # cd .. && rm -fr 'trash directory'
471 # but that means we forbid any tests that use their own
472 # subdirectory from calling test_done without coming back
473 # to where they started from.
474 # The Makefile provided will clean this test area so
475 # we will leave things as they are.
477 say_color pass
"passed all $msg"
479 test -d "$remove_trash" &&
480 cd "$(dirname "$remove_trash")" &&
481 rm -rf "$(basename "$remove_trash")"
486 say_color error
"failed $test_failure among $msg"
492 # Test the binaries we have just built. The tests are kept in
493 # t/ subdirectory and are run in 'trash directory' subdirectory.
494 TEST_DIRECTORY
=$
(pwd)
495 PATH
=$TEST_DIRECTORY/..
:$PATH
496 GIT_EXEC_PATH
=$
(pwd)/..
497 GIT_TEMPLATE_DIR
=$
(pwd)/..
/templates
/blt
499 GIT_CONFIG_NOSYSTEM
=1
500 GIT_CONFIG_NOGLOBAL
=1
501 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
503 GITPERLLIB
=$
(pwd)/..
/perl
/blib
/lib
:$
(pwd)/..
/perl
/blib
/arch
/auto
/Git
505 test -d ..
/templates
/blt ||
{
506 error
"You haven't built things yet, have you?"
509 if ! test -x ..
/test-chmtime
; then
510 echo >&2 'You need to build test-chmtime:'
511 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
515 . ..
/GIT-BUILD-OPTIONS
518 test="trash directory.$(basename "$0" .sh)"
519 test ! -z "$debug" || remove_trash
="$TEST_DIRECTORY/$test"
522 echo >&5 "FATAL: Cannot prepare test area"
526 test_create_repo
"$test"
527 # Use -P to resolve symlinks in our working directory so that the cwd
528 # in subprocesses like git equals our $PWD (for pathname comparisons).
529 cd -P "$test" ||
exit 1
531 this_test
=$
(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
532 for skp
in $GIT_SKIP_TESTS
535 for skp
in $GIT_SKIP_TESTS
544 say_color skip
>&3 "skipping test $this_test altogether"
545 say_color skip
"skip all tests in $this_test"